using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Org.Shokai.Util;

namespace GPSTool
{
    public partial class Form1 : Form
    {
        GpsConnector gps;
        TraceForm traceForm;

        public Form1()
        {
            InitializeComponent();

            gps = new GpsConnector();
            traceForm = new TraceForm();
#if DEBUG
            traceForm.Show();
            traceForm.write("---start---");
#endif

            webBrowser.Url = new Uri(textBoxUri.Text);

            // PortName
            for (int i = 1; i <= 20; i++) // R{{bNXɃACeǉ
            {
                comboBoxSerialPort.Items.Add("COM" + i);
            }
            comboBoxSerialPort.SelectedIndex = 0;

            //BaudRate
            int baud = 300;
            for (int i = 1; i <= 6; i++)
            {
                comboBoxSerialBaud.Items.Add(baud*=2);
            }
            comboBoxSerialBaud.SelectedIndex = 3;
        }

        #region UI Event
        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (!gps.IsOpen)
            {
                gps.PortName = comboBoxSerialPort.SelectedItem.ToString();
                gps.BaudRate = Int32.Parse(comboBoxSerialBaud.SelectedItem.ToString());
                gps.connect();
                if (gps.IsOpen)
                {
                    buttonConnect.Text = "ؒf";
                    comboBoxSerialPort.Enabled = false;
                    comboBoxSerialBaud.Enabled = false;
                }
            }
            else
            {
                gps.close();
                if (!gps.IsOpen)
                {
                    buttonConnect.Text = "ڑ";
                    comboBoxSerialPort.Enabled = true;
                    comboBoxSerialBaud.Enabled = true;
                }
            }
        }

        private void buttonMapMove_Click(object sender, EventArgs e)
        {
            String uri = "http://maps.yahoo.com/index.php#mvt=m&maxp=search&trf=0&lon=" + gps.gpsData.lon + "&lat=" + gps.gpsData.lat + "&mag=6";
            webBrowser.Url = new Uri(uri);
            textBoxUri.Text = uri;
            traceForm.write(uri);
            traceForm.write("ܓx:" + gps.gpsData.lon + " ox:" + gps.gpsData.lat);
        }

        private void buttonShowGpsStatus_Click(object sender, EventArgs e)
        {
            String gpsStat = gps.toString();
            traceForm.write(gpsStat);
            MessageBox.Show(gpsStat, "GPSXe[^X");
        }

        private void buttonGoUri_Click(object sender, EventArgs e)
        {
            webBrowser.Url = new Uri(textBoxUri.Text);
        }

        #endregion

        private void textBoxUri_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                webBrowser.Url = new Uri(textBoxUri.Text);
            }
        }


    }
}